<script setup>
import { useVuelidate } from "@vuelidate/core";
import {
  required,
  email,
  minLength,
  sameAs,
  alphaNum,
  helpers,
} from "@vuelidate/validators";
import { validPassword } from "@/validators";
import { reactive, computed, ref, onMounted } from "vue";
import { useRouter, useRoute } from "vue-router";
import { mdiAccount, mdiAsterisk } from "@mdi/js";
import FullScreenSection from "@/components/FullScreenSection.vue";
import SectionComponent from "@/components/SectionComponent.vue";
import CheckRadioPicker from "@/components/CheckRadioPicker.vue";
import Field from "@/components/Field.vue";
import Control from "@/components/Control.vue";
import ModalBox from "@/components/ModalBox.vue";
import Divider from "@/components/Divider.vue";
import JbButton from "@/components/JbButton.vue";
import JbButtons from "@/components/JbButtons.vue";
import AuthService from "@/api/authService";
import { useToast } from "vue-toastification";
const alphaNumAndDotValidator = helpers.regex("alphaNumAndDot", /^[a-z\d.]*$/i);
const router = useRouter();
const route = useRoute();
const toast = useToast();
const isModalDangerActive = ref(false);
const password = reactive({
  pass: "",
  confirm: "",
});
const rules = computed(() => {
  return {
    pass: { required, minLength: minLength(8),
      validators: {
        $validator: validPassword,
        $message:
          "The password requires an uppercase, lowercase, number and special character",
      }, },
    confirm: { required, sameAs: sameAs(password.pass) },
  };
});
const v$ = useVuelidate(rules, password);
// const password = ref("");
const keyValue = ref(false);
const key = ref(route.params.key);
onMounted(() => {
  //check activation link
  console.log("activation link", key.value);
  AuthService.checkActivationKey(key.value).then((data) => {
    keyValue.value = data?.data?.success;

    if (!data?.data?.success) {
      console.log("link not valid");
      console.log("link not valid", data?.data?.message);
      toast.error(data?.data?.message || "link not valid");
    }
  });
});
// password Reset
const submit = () => {
  // vuelidate validation
  v$.value.$validate();
  // if success
  if (!v$.value.$error) {
    console.log("key", key.value);
    AuthService.activateAccount({
      key: key.value,
      password: password.pass,
    }).then((data) => {
      // console.log("pass", pass);
      if (data?.success) {
        toast.success(data?.message);
        // toast("Account activated Successfully");
        router.push("/");
      } else {
        toast.error(data?.message);
        router.push("/");
      }
    });
  }
};
 const hidePassword = ref(true);
   const passwordFieldType = computed(() => hidePassword.value ? "password" : "text");
// 
 const hidePassword1 = ref(true);
   const passwordFieldType1 = computed(() => hidePassword1.value ? "password" : "text");
</script>

<template>
<Transition :duration="{ enter: 500, leave: 800 }" name="nested">
  <modal-box
    v-model="isModalDangerActive"
    button="danger"
    has-cancel
    class="py-6"
  >
    <div class="py-8">
      <h3 class="text-center pb-6 text-xl font-semibold">Please Confirm</h3>
      <p class="text-gray-250 font-semibold">
        We have send you a link to Reset Your Password
      </p>
    </div>
    <jb-button
      color=""
      label="ok"
      class="mt-2 bg-pink-250 text-white px-6 font-seemibold py-2 rounded-lg"
      to="/otp"
    />
  </modal-box>
</Transition>
  <full-screen-section
    v-slot="{ cardClass, cardRounded }"
    bg="login"
    class="h-full py-6 px-4"
  >
    <div class="row w-full justify-between my-1 mb-4 px-32 py-10 h-full">
      <img src="@/assets/icons/logo.svg" />
    </div>
    <div class="flex justify-center justify-items-center">
      <div
        class="bg-white md:inline-flex px-14 py-20 w-4/5 rounded-lg shadow-pink-150 dropShadow-outer-lg"
      >
        <span class="md:w-1/2 w-full md:px-10 px-2">
          <h5 class="text-center text-pink-250 font-semibold text-3xl mb-4">
            "Labour Care Guide"
          </h5>
          <center class="py-10">
            <img
              src="@/assets/icons/login-icon.svg"
              style="width: 240px"
              alt="logo"
            />
          </center>
        </span>
        <section-component
          v-if="!keyValue"
          class="md:w-1/2 w-full md:px-10 py-8 px-2 shadow-none"
          :class="cardClass"
          :rounded="cardRounded"
          form
        >
          <p class="pt-10 mb-6 text-lg text-center">
            This account activation link has expired!
          </p>
          <router-link to="/">
            <jb-buttons>
              <jb-button
                color=""
                label="ok"
                class="mt-2 bg-pink-250 text-white w-full font-seemibold text-lg py-3 rounded-lg"
              />
            </jb-buttons>
          </router-link>
        </section-component>
        <section-component
          v-else
          class="md:w-1/2 w-full md:px-10 py-8 px-2 shadow-none"
          :class="cardClass"
          :rounded="cardRounded"
          form
        >
          <p class="pt-10 mb-6 text-lg text-center font-semibold">Create New Password</p>
          <field label="Password">
            <div class="flex-wrap">
              <control
                v-model="password.pass"
                placeholder="Password"
                :type="passwordFieldType"
                name="password"
                @input="v$.pass.$touch()"
                
              />
              <img class="absolute -mt-6 right-72 cursor-pointer" src="@/assets/icons/eyes.svg" @click="hidePassword = !hidePassword"/>
              <span class="text-pink-250" v-if="v$.pass.$error">
                {{ v$.pass.$errors[0].$message }}
              </span>
            </div>
          </field>
          <field label="Confirm Password">
            <div class="flex-wrap">
              <control
                v-model="password.confirm"
                placeholder="Password"
                :type="passwordFieldType1"
                name="password"
                @input="v$.confirm.$touch()"
                
              />
              <img class="absolute -mt-6 right-72 cursor-pointer" src="@/assets/icons/eyes.svg" @click="hidePassword1 = !hidePassword1"/>
              <span class="text-pink-250" v-if="v$.confirm.$error">
                {{ v$.confirm.$errors[0].$message }}
              </span>
            </div>
          </field>
          <jb-buttons>
            <jb-button
              color=""
              label="Submit"
              class="mt-2 bg-pink-250 text-white w-full font-seemibold text-lg py-3 rounded-lg"
              @click.prevent="submit"
            />
          </jb-buttons>
        </section-component>
      </div>
    </div>
  </full-screen-section>
</template>
